<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBoardingPassInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBoardingPassInfo
 * @subpackage Arrays
 */
class ArrayOfBoardingPassInfo extends AbstractStructArrayBase
{
    /**
     * The BoardingPassInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\BoardingPassInfo[]
     */
    public $BoardingPassInfo;
    /**
     * Constructor method for ArrayOfBoardingPassInfo
     * @uses ArrayOfBoardingPassInfo::setBoardingPassInfo()
     * @param \App|C\StructType\BoardingPassInfo[] $boardingPassInfo
     */
    public function __construct(array $boardingPassInfo = array())
    {
        $this
            ->setBoardingPassInfo($boardingPassInfo);
    }
    /**
     * Get BoardingPassInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\BoardingPassInfo[]|null
     */
    public function getBoardingPassInfo()
    {
        return isset($this->BoardingPassInfo) ? $this->BoardingPassInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBoardingPassInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBoardingPassInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBoardingPassInfoForArrayConstraintsFromSetBoardingPassInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBoardingPassInfoBoardingPassInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfBoardingPassInfoBoardingPassInfoItem instanceof \App|C\StructType\BoardingPassInfo) {
                $invalidValues[] = is_object($arrayOfBoardingPassInfoBoardingPassInfoItem) ? get_class($arrayOfBoardingPassInfoBoardingPassInfoItem) : sprintf('%s(%s)', gettype($arrayOfBoardingPassInfoBoardingPassInfoItem), var_export($arrayOfBoardingPassInfoBoardingPassInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BoardingPassInfo property can only contain items of type \App|C\StructType\BoardingPassInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BoardingPassInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BoardingPassInfo[] $boardingPassInfo
     * @return \App|C\ArrayType\ArrayOfBoardingPassInfo
     */
    public function setBoardingPassInfo(array $boardingPassInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($boardingPassInfoArrayErrorMessage = self::validateBoardingPassInfoForArrayConstraintsFromSetBoardingPassInfo($boardingPassInfo))) {
            throw new \InvalidArgumentException($boardingPassInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($boardingPassInfo) || (is_array($boardingPassInfo) && empty($boardingPassInfo))) {
            unset($this->BoardingPassInfo);
        } else {
            $this->BoardingPassInfo = $boardingPassInfo;
        }
        return $this;
    }
    /**
     * Add item to BoardingPassInfo value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BoardingPassInfo $item
     * @return \App|C\ArrayType\ArrayOfBoardingPassInfo
     */
    public function addToBoardingPassInfo(\App|C\StructType\BoardingPassInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\BoardingPassInfo) {
            throw new \InvalidArgumentException(sprintf('The BoardingPassInfo property can only contain items of type \App|C\StructType\BoardingPassInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BoardingPassInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\BoardingPassInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\BoardingPassInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\BoardingPassInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\BoardingPassInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\BoardingPassInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BoardingPassInfo
     */
    public function getAttributeName()
    {
        return 'BoardingPassInfo';
    }
}
