<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventMap StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EventMap
 * @subpackage Structs
 */
class EventMap extends AbstractStructBase
{
    /**
     * The request
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventMapRequest
     */
    public $request;
    /**
     * The FlightCancelled
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventInfo
     */
    public $FlightCancelled;
    /**
     * The FlightNumberChange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventInfo
     */
    public $FlightNumberChange;
    /**
     * The FlightTimeChange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventInfo
     */
    public $FlightTimeChange;
    /**
     * The FlightTransfer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventInfo
     */
    public $FlightTransfer;
    /**
     * The SegmentCancelled
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\EventInfo
     */
    public $SegmentCancelled;
    /**
     * Constructor method for EventMap
     * @uses EventMap::setRequest()
     * @uses EventMap::setFlightCancelled()
     * @uses EventMap::setFlightNumberChange()
     * @uses EventMap::setFlightTimeChange()
     * @uses EventMap::setFlightTransfer()
     * @uses EventMap::setSegmentCancelled()
     * @param \App|C\StructType\EventMapRequest $request
     * @param \App|C\StructType\EventInfo $flightCancelled
     * @param \App|C\StructType\EventInfo $flightNumberChange
     * @param \App|C\StructType\EventInfo $flightTimeChange
     * @param \App|C\StructType\EventInfo $flightTransfer
     * @param \App|C\StructType\EventInfo $segmentCancelled
     */
    public function __construct(\App|C\StructType\EventMapRequest $request = null, \App|C\StructType\EventInfo $flightCancelled = null, \App|C\StructType\EventInfo $flightNumberChange = null, \App|C\StructType\EventInfo $flightTimeChange = null, \App|C\StructType\EventInfo $flightTransfer = null, \App|C\StructType\EventInfo $segmentCancelled = null)
    {
        $this
            ->setRequest($request)
            ->setFlightCancelled($flightCancelled)
            ->setFlightNumberChange($flightNumberChange)
            ->setFlightTimeChange($flightTimeChange)
            ->setFlightTransfer($flightTransfer)
            ->setSegmentCancelled($segmentCancelled);
    }
    /**
     * Get request value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventMapRequest|null
     */
    public function getRequest()
    {
        return isset($this->request) ? $this->request : null;
    }
    /**
     * Set request value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventMapRequest $request
     * @return \App|C\StructType\EventMap
     */
    public function setRequest(\App|C\StructType\EventMapRequest $request = null)
    {
        if (is_null($request) || (is_array($request) && empty($request))) {
            unset($this->request);
        } else {
            $this->request = $request;
        }
        return $this;
    }
    /**
     * Get FlightCancelled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventInfo|null
     */
    public function getFlightCancelled()
    {
        return isset($this->FlightCancelled) ? $this->FlightCancelled : null;
    }
    /**
     * Set FlightCancelled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventInfo $flightCancelled
     * @return \App|C\StructType\EventMap
     */
    public function setFlightCancelled(\App|C\StructType\EventInfo $flightCancelled = null)
    {
        if (is_null($flightCancelled) || (is_array($flightCancelled) && empty($flightCancelled))) {
            unset($this->FlightCancelled);
        } else {
            $this->FlightCancelled = $flightCancelled;
        }
        return $this;
    }
    /**
     * Get FlightNumberChange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventInfo|null
     */
    public function getFlightNumberChange()
    {
        return isset($this->FlightNumberChange) ? $this->FlightNumberChange : null;
    }
    /**
     * Set FlightNumberChange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventInfo $flightNumberChange
     * @return \App|C\StructType\EventMap
     */
    public function setFlightNumberChange(\App|C\StructType\EventInfo $flightNumberChange = null)
    {
        if (is_null($flightNumberChange) || (is_array($flightNumberChange) && empty($flightNumberChange))) {
            unset($this->FlightNumberChange);
        } else {
            $this->FlightNumberChange = $flightNumberChange;
        }
        return $this;
    }
    /**
     * Get FlightTimeChange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventInfo|null
     */
    public function getFlightTimeChange()
    {
        return isset($this->FlightTimeChange) ? $this->FlightTimeChange : null;
    }
    /**
     * Set FlightTimeChange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventInfo $flightTimeChange
     * @return \App|C\StructType\EventMap
     */
    public function setFlightTimeChange(\App|C\StructType\EventInfo $flightTimeChange = null)
    {
        if (is_null($flightTimeChange) || (is_array($flightTimeChange) && empty($flightTimeChange))) {
            unset($this->FlightTimeChange);
        } else {
            $this->FlightTimeChange = $flightTimeChange;
        }
        return $this;
    }
    /**
     * Get FlightTransfer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventInfo|null
     */
    public function getFlightTransfer()
    {
        return isset($this->FlightTransfer) ? $this->FlightTransfer : null;
    }
    /**
     * Set FlightTransfer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventInfo $flightTransfer
     * @return \App|C\StructType\EventMap
     */
    public function setFlightTransfer(\App|C\StructType\EventInfo $flightTransfer = null)
    {
        if (is_null($flightTransfer) || (is_array($flightTransfer) && empty($flightTransfer))) {
            unset($this->FlightTransfer);
        } else {
            $this->FlightTransfer = $flightTransfer;
        }
        return $this;
    }
    /**
     * Get SegmentCancelled value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\EventInfo|null
     */
    public function getSegmentCancelled()
    {
        return isset($this->SegmentCancelled) ? $this->SegmentCancelled : null;
    }
    /**
     * Set SegmentCancelled value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\EventInfo $segmentCancelled
     * @return \App|C\StructType\EventMap
     */
    public function setSegmentCancelled(\App|C\StructType\EventInfo $segmentCancelled = null)
    {
        if (is_null($segmentCancelled) || (is_array($segmentCancelled) && empty($segmentCancelled))) {
            unset($this->SegmentCancelled);
        } else {
            $this->SegmentCancelled = $segmentCancelled;
        }
        return $this;
    }
}
