<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PingRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PingRequest
 * @subpackage Structs
 */
class PingRequest extends AbstractRequest
{
    /**
     * The DateTimeTest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DateTimeTest;
    /**
     * The StringTest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StringTest;
    /**
     * Constructor method for PingRequest
     * @uses PingRequest::setDateTimeTest()
     * @uses PingRequest::setStringTest()
     * @param string $dateTimeTest
     * @param string $stringTest
     */
    public function __construct($dateTimeTest = null, $stringTest = null)
    {
        $this
            ->setDateTimeTest($dateTimeTest)
            ->setStringTest($stringTest);
    }
    /**
     * Get DateTimeTest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDateTimeTest()
    {
        return isset($this->DateTimeTest) ? $this->DateTimeTest : null;
    }
    /**
     * Set DateTimeTest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dateTimeTest
     * @return \App|C\StructType\PingRequest
     */
    public function setDateTimeTest($dateTimeTest = null)
    {
        // validation for constraint: string
        if (!is_null($dateTimeTest) && !is_string($dateTimeTest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateTimeTest, true), gettype($dateTimeTest)), __LINE__);
        }
        if (is_null($dateTimeTest) || (is_array($dateTimeTest) && empty($dateTimeTest))) {
            unset($this->DateTimeTest);
        } else {
            $this->DateTimeTest = $dateTimeTest;
        }
        return $this;
    }
    /**
     * Get StringTest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStringTest()
    {
        return isset($this->StringTest) ? $this->StringTest : null;
    }
    /**
     * Set StringTest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stringTest
     * @return \App|C\StructType\PingRequest
     */
    public function setStringTest($stringTest = null)
    {
        // validation for constraint: string
        if (!is_null($stringTest) && !is_string($stringTest)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stringTest, true), gettype($stringTest)), __LINE__);
        }
        if (is_null($stringTest) || (is_array($stringTest) && empty($stringTest))) {
            unset($this->StringTest);
        } else {
            $this->StringTest = $stringTest;
        }
        return $this;
    }
}
