<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrepareBookingModificationResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PrepareBookingModificationResponse
 * @subpackage Structs
 */
class PrepareBookingModificationResponse extends AbstractResponse
{
    /**
     * The PrepareBookingModificationResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\PrepareBookingModificationResponse
     */
    public $PrepareBookingModificationResult;
    /**
     * The Booking
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Booking
     */
    public $Booking;
    /**
     * The FareInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfoPrepare
     */
    public $FareInfo;
    /**
     * The OptionalSpecialServices
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSpecialService
     */
    public $OptionalSpecialServices;
    /**
     * The Passengers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfPassenger
     */
    public $Passengers;
    /**
     * The SpecialServices
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSpecialService
     */
    public $SpecialServices;
    /**
     * Constructor method for PrepareBookingModificationResponse
     * @uses PrepareBookingModificationResponse::setPrepareBookingModificationResult()
     * @uses PrepareBookingModificationResponse::setBooking()
     * @uses PrepareBookingModificationResponse::setFareInfo()
     * @uses PrepareBookingModificationResponse::setOptionalSpecialServices()
     * @uses PrepareBookingModificationResponse::setPassengers()
     * @uses PrepareBookingModificationResponse::setSpecialServices()
     * @param \App|C\StructType\PrepareBookingModificationResponse $prepareBookingModificationResult
     * @param \App|C\StructType\Booking $booking
     * @param \App|C\StructType\FareInfoPrepare $fareInfo
     * @param \App|C\ArrayType\ArrayOfSpecialService $optionalSpecialServices
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @param \App|C\ArrayType\ArrayOfSpecialService $specialServices
     */
    public function __construct(\App|C\StructType\PrepareBookingModificationResponse $prepareBookingModificationResult = null, \App|C\StructType\Booking $booking = null, \App|C\StructType\FareInfoPrepare $fareInfo = null, \App|C\ArrayType\ArrayOfSpecialService $optionalSpecialServices = null, \App|C\ArrayType\ArrayOfPassenger $passengers = null, \App|C\ArrayType\ArrayOfSpecialService $specialServices = null)
    {
        $this
            ->setPrepareBookingModificationResult($prepareBookingModificationResult)
            ->setBooking($booking)
            ->setFareInfo($fareInfo)
            ->setOptionalSpecialServices($optionalSpecialServices)
            ->setPassengers($passengers)
            ->setSpecialServices($specialServices);
    }
    /**
     * Get PrepareBookingModificationResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\PrepareBookingModificationResponse|null
     */
    public function getPrepareBookingModificationResult()
    {
        return isset($this->PrepareBookingModificationResult) ? $this->PrepareBookingModificationResult : null;
    }
    /**
     * Set PrepareBookingModificationResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\PrepareBookingModificationResponse $prepareBookingModificationResult
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setPrepareBookingModificationResult(\App|C\StructType\PrepareBookingModificationResponse $prepareBookingModificationResult = null)
    {
        if (is_null($prepareBookingModificationResult) || (is_array($prepareBookingModificationResult) && empty($prepareBookingModificationResult))) {
            unset($this->PrepareBookingModificationResult);
        } else {
            $this->PrepareBookingModificationResult = $prepareBookingModificationResult;
        }
        return $this;
    }
    /**
     * Get Booking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Booking|null
     */
    public function getBooking()
    {
        return isset($this->Booking) ? $this->Booking : null;
    }
    /**
     * Set Booking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Booking $booking
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setBooking(\App|C\StructType\Booking $booking = null)
    {
        if (is_null($booking) || (is_array($booking) && empty($booking))) {
            unset($this->Booking);
        } else {
            $this->Booking = $booking;
        }
        return $this;
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfoPrepare|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfoPrepare $fareInfo
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setFareInfo(\App|C\StructType\FareInfoPrepare $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get OptionalSpecialServices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSpecialService|null
     */
    public function getOptionalSpecialServices()
    {
        return isset($this->OptionalSpecialServices) ? $this->OptionalSpecialServices : null;
    }
    /**
     * Set OptionalSpecialServices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSpecialService $optionalSpecialServices
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setOptionalSpecialServices(\App|C\ArrayType\ArrayOfSpecialService $optionalSpecialServices = null)
    {
        if (is_null($optionalSpecialServices) || (is_array($optionalSpecialServices) && empty($optionalSpecialServices))) {
            unset($this->OptionalSpecialServices);
        } else {
            $this->OptionalSpecialServices = $optionalSpecialServices;
        }
        return $this;
    }
    /**
     * Get Passengers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfPassenger|null
     */
    public function getPassengers()
    {
        return isset($this->Passengers) ? $this->Passengers : null;
    }
    /**
     * Set Passengers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setPassengers(\App|C\ArrayType\ArrayOfPassenger $passengers = null)
    {
        if (is_null($passengers) || (is_array($passengers) && empty($passengers))) {
            unset($this->Passengers);
        } else {
            $this->Passengers = $passengers;
        }
        return $this;
    }
    /**
     * Get SpecialServices value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSpecialService|null
     */
    public function getSpecialServices()
    {
        return isset($this->SpecialServices) ? $this->SpecialServices : null;
    }
    /**
     * Set SpecialServices value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSpecialService $specialServices
     * @return \App|C\StructType\PrepareBookingModificationResponse
     */
    public function setSpecialServices(\App|C\ArrayType\ArrayOfSpecialService $specialServices = null)
    {
        if (is_null($specialServices) || (is_array($specialServices) && empty($specialServices))) {
            unset($this->SpecialServices);
        } else {
            $this->SpecialServices = $specialServices;
        }
        return $this;
    }
}
