<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceDataPnrContact StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceDataPnrContact
 * @subpackage Structs
 */
class SpecialServiceDataPnrContact extends ApiObject
{
    /**
     * The ContactCellPhone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactCellPhone;
    /**
     * The ContactEmail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactEmail;
    /**
     * The ContactFaxNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactFaxNumber;
    /**
     * The ContactFullName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactFullName;
    /**
     * The ContactHomePhone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactHomePhone;
    /**
     * The ContactWorkPhone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ContactWorkPhone;
    /**
     * Constructor method for SpecialServiceDataPnrContact
     * @uses SpecialServiceDataPnrContact::setContactCellPhone()
     * @uses SpecialServiceDataPnrContact::setContactEmail()
     * @uses SpecialServiceDataPnrContact::setContactFaxNumber()
     * @uses SpecialServiceDataPnrContact::setContactFullName()
     * @uses SpecialServiceDataPnrContact::setContactHomePhone()
     * @uses SpecialServiceDataPnrContact::setContactWorkPhone()
     * @param string $contactCellPhone
     * @param string $contactEmail
     * @param string $contactFaxNumber
     * @param string $contactFullName
     * @param string $contactHomePhone
     * @param string $contactWorkPhone
     */
    public function __construct($contactCellPhone = null, $contactEmail = null, $contactFaxNumber = null, $contactFullName = null, $contactHomePhone = null, $contactWorkPhone = null)
    {
        $this
            ->setContactCellPhone($contactCellPhone)
            ->setContactEmail($contactEmail)
            ->setContactFaxNumber($contactFaxNumber)
            ->setContactFullName($contactFullName)
            ->setContactHomePhone($contactHomePhone)
            ->setContactWorkPhone($contactWorkPhone);
    }
    /**
     * Get ContactCellPhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactCellPhone()
    {
        return isset($this->ContactCellPhone) ? $this->ContactCellPhone : null;
    }
    /**
     * Set ContactCellPhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactCellPhone
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactCellPhone($contactCellPhone = null)
    {
        // validation for constraint: string
        if (!is_null($contactCellPhone) && !is_string($contactCellPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactCellPhone, true), gettype($contactCellPhone)), __LINE__);
        }
        if (is_null($contactCellPhone) || (is_array($contactCellPhone) && empty($contactCellPhone))) {
            unset($this->ContactCellPhone);
        } else {
            $this->ContactCellPhone = $contactCellPhone;
        }
        return $this;
    }
    /**
     * Get ContactEmail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactEmail()
    {
        return isset($this->ContactEmail) ? $this->ContactEmail : null;
    }
    /**
     * Set ContactEmail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactEmail
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactEmail($contactEmail = null)
    {
        // validation for constraint: string
        if (!is_null($contactEmail) && !is_string($contactEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactEmail, true), gettype($contactEmail)), __LINE__);
        }
        if (is_null($contactEmail) || (is_array($contactEmail) && empty($contactEmail))) {
            unset($this->ContactEmail);
        } else {
            $this->ContactEmail = $contactEmail;
        }
        return $this;
    }
    /**
     * Get ContactFaxNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactFaxNumber()
    {
        return isset($this->ContactFaxNumber) ? $this->ContactFaxNumber : null;
    }
    /**
     * Set ContactFaxNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactFaxNumber
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactFaxNumber($contactFaxNumber = null)
    {
        // validation for constraint: string
        if (!is_null($contactFaxNumber) && !is_string($contactFaxNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactFaxNumber, true), gettype($contactFaxNumber)), __LINE__);
        }
        if (is_null($contactFaxNumber) || (is_array($contactFaxNumber) && empty($contactFaxNumber))) {
            unset($this->ContactFaxNumber);
        } else {
            $this->ContactFaxNumber = $contactFaxNumber;
        }
        return $this;
    }
    /**
     * Get ContactFullName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactFullName()
    {
        return isset($this->ContactFullName) ? $this->ContactFullName : null;
    }
    /**
     * Set ContactFullName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactFullName
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactFullName($contactFullName = null)
    {
        // validation for constraint: string
        if (!is_null($contactFullName) && !is_string($contactFullName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactFullName, true), gettype($contactFullName)), __LINE__);
        }
        if (is_null($contactFullName) || (is_array($contactFullName) && empty($contactFullName))) {
            unset($this->ContactFullName);
        } else {
            $this->ContactFullName = $contactFullName;
        }
        return $this;
    }
    /**
     * Get ContactHomePhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactHomePhone()
    {
        return isset($this->ContactHomePhone) ? $this->ContactHomePhone : null;
    }
    /**
     * Set ContactHomePhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactHomePhone
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactHomePhone($contactHomePhone = null)
    {
        // validation for constraint: string
        if (!is_null($contactHomePhone) && !is_string($contactHomePhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactHomePhone, true), gettype($contactHomePhone)), __LINE__);
        }
        if (is_null($contactHomePhone) || (is_array($contactHomePhone) && empty($contactHomePhone))) {
            unset($this->ContactHomePhone);
        } else {
            $this->ContactHomePhone = $contactHomePhone;
        }
        return $this;
    }
    /**
     * Get ContactWorkPhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContactWorkPhone()
    {
        return isset($this->ContactWorkPhone) ? $this->ContactWorkPhone : null;
    }
    /**
     * Set ContactWorkPhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contactWorkPhone
     * @return \App|C\StructType\SpecialServiceDataPnrContact
     */
    public function setContactWorkPhone($contactWorkPhone = null)
    {
        // validation for constraint: string
        if (!is_null($contactWorkPhone) && !is_string($contactWorkPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactWorkPhone, true), gettype($contactWorkPhone)), __LINE__);
        }
        if (is_null($contactWorkPhone) || (is_array($contactWorkPhone) && empty($contactWorkPhone))) {
            unset($this->ContactWorkPhone);
        } else {
            $this->ContactWorkPhone = $contactWorkPhone;
        }
        return $this;
    }
}
